#
# spec file for package perl-Tk
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-Tk
Version:        804.033
Release:        2.3
Summary:        Perl Tk
License:        (GPL-1.0+ or Artistic-1.0) and Zlib
Group:          Development/Libraries/Perl
Url:            http://cpan.org/modules/by-module/Tk/
Source:         http://www.cpan.org/modules/by-module/Tk/Tk-%{version}.tar.gz
Patch1:         Tk-804.029-macro.diff
Patch2:         Tk-804.029-null.diff
Patch3:         Tk-804.029-refcnt.diff
Patch4:         Tk-804.029-event.diff
BuildRequires:  libpng-devel
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  xkeyboard-config
BuildRequires:  xorg-x11
BuildRequires:  xorg-x11-Xnest
BuildRequires:  xorg-x11-Xvfb
BuildRequires:  xorg-x11-devel
BuildRequires:  xorg-x11-fonts
BuildRequires:  xorg-x11-fonts-100dpi
BuildRequires:  xorg-x11-fonts-scalable
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%{perl_requires}
%ifnarch s390 s390x
BuildRequires:  xorg-x11-server
%endif

%description
Perl Tk is an enhancement for Perl. It combines the well structured
graphical library Tk with the powerful scripting language Perl.

%package devel
Summary:        Perl Tk
Group:          Development/Libraries/Perl
Requires:       %{name} = %{version}

%description devel
Perl Tk is an enhancement for Perl. It combines the well structured
graphical library Tk with the powerful scripting language Perl.

%prep
%setup -q -n Tk-%{version}
%patch1
%patch2
%patch3
%patch4

%build
find -name "*.orig" -exec rm {} \;
for file in `find -type f` ; do
  grep -q "%{_prefix}/local/bin/perl" $file && \
      sed -i -e "s@%{_prefix}/local/bin/perl@%{_bindir}/perl@g" "$file"
  grep -q "%{_prefix}/local/bin/nperl" $file && \
      sed -i -e "s@%{_prefix}/local/bin/nperl@%{_bindir}/nperl@g" "$file" 
  grep -q "#!\s*/bin/perl" $file && \
      sed -i -e "s@/bin/perl@%{_bindir}/perl@g" "$file"
  grep -q "#!\s*/tools/local/perl" $file && \
      sed -i -e "s@/tools/local/perl@%{_bindir}/perl@g" "$file"
  grep -q "%{_prefix}/local/bin/new/perl" $file && \
      sed -i -e "s@%{_prefix}/local/bin/new/perl@%{_bindir}/perl@g" "$file"
done
#disable test that require Test
mv t/browseentry-grabtest.t t/browseentry-grabtest.tt
mv t/browseentry2.t t/browseentry2.tt
mv t/entry.t t/entry.tt
mv t/listbox.t t/listbox.tt
# disable test that seems to fail at random
mv t/fileevent2.t t/fileevent2.tt
perl Makefile.PL XFT=1
make %{?_smp_mflags} CFLAGS="%{optflags} -Wall -fpic"

%check
Xvfb :95 -screen 0 1280x1024x24 & #430569
trap "kill $!" EXIT
sleep 5
DISPLAY=:95 make test %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install_vendor
%perl_process_packlist
rm -f %{buildroot}/%{perl_vendorarch}/fix_4_os2.pl

%files
%defattr(-,root,root)
%doc COPYING Change.log Changes Funcs.doc INSTALL PPM-HowTo README* ToDo VERSIONS
%{_mandir}/man?/*
%{_bindir}/*
%{perl_vendorarch}/Tie
%{perl_vendorarch}/Tk
%{perl_vendorarch}/Tk.*
%{perl_vendorarch}/auto/Tk
%exclude %{perl_vendorarch}/Tk/pTk
%exclude %{perl_vendorarch}/Tk/*.h

%files devel
%defattr(-,root,root)
%{perl_vendorarch}/Tk/pTk
%{perl_vendorarch}/Tk/*.h

%changelog
* Mon Aug 31 2015 tchvatal@suse.com
- Remove provides on quite wrong header file in devel subpkg pointing
  to perl 5.8.8 dir
- Use inline parameter for sed, well this should be redone more
- Cleanup bit with spec-cleaner
* Mon Aug 31 2015 dimstar@opensuse.org
- Update to version 804.033:
  + New t/pod.t test (github pull request #16).
- Drop Tk-804.032-tkglue.diff and Tk-804.032-freetype.diff: Fixed
  upstream.
* Sat Jul 19 2014 schwab@linux-m68k.org
- Update to 804.032
  * RT# 88210: fix compilation for perl 5.19.0+ ("undef bool")
  * RT# 90077: floating number issue with -textvariable variables
  * RT# 89621: avoid segfaults during global destruction (by Gisle Aas)
  * RT# 87016: compatibility for libpng 1.6.x
  * RT# 86988: use cflags/libs information from pkg-config zlib
  * RT# 89261: split Tk/ColorEditor.pm into three .pm files
  * RT# 71718: fix compilation issue with 64bit Strawberry Perl (Tk_Cursor)
  * Fail gracefully if no font could be allocated
- Tk-804.032-tkglue.diff: no segfaults if Tk::MainWindow::Create was
  called without args
- Tk-804.032-freetype.diff: look also for /usr/include/freetype2/freetype.h
- Tk-804.029-lib64.diff, Tk-804.029-xorg.diff, Tk-804.030-libpng16.diff:
  remove upstreamed patches
* Mon Jul  8 2013 coolo@suse.com
- updated to 804.031
  Fixes
  The CopSTASH_set fix did not work in 804.030_501 because of a
  missing file in the tarball. Now fixed.
  Tk::MakeDepend parses gcc's inc search list now and does not rely
  anymore on $Config{usrinc}. This helps when include files are
  partially in "multiarch" subdirectories (e.g. in Debian/sid) or when
  $Config{usrinc} is incorrect (e.g. in ActivePerl+gcc builds).
  RT #85407 and http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=708624
  Helping Debian's build process by skipping the quilt state directory
  http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=708635
  Improving build process for ActivePerl+gcc (RT #74036); see also
  README-ActiveState.txt.
  Use pkg-config for determining libpng cflags and libs.
  Tk-804.030_501 release (2013-05-18)
  - ---------------------
  Fixes
  Should compile again with older perls: SvNV_nomg is not available with
  perls older than 5.13.2, and CopSTASH_set(..., NULL) is not possible
  with threaded 5.16.x and older.
  Tk-804.030_500 release (2013-05-18)
  - ---------------------
  Incompatible changes
  The Tk::Text::Contents() method does not return an extra newline
  anymore (RT #83124). The version number of Tk::Text was incremented
  to 4.029 and may be used to detect the change.
  Fixes
  RT #78824: fixed compilation under threaded bleadperl (5.17.x)
  Fix for internal magic handling, needed for perl 5.17.2 and newer.
  Fixed myConfig issue with perl 5.17.x.
  SvUPGRADE() is no longer an expression since perl 5.17.7.
  Off-by-one error in Tk::Table::clear method (problem spotted by David
  Overeem).
* Thu Feb 28 2013 pgajdos@suse.com
- builds also against libpng16
  * libpng16.patch
* Fri Oct 21 2011 vcizek@suse.com
- update to 804.030
  Many bugfixes (see Changes)
  New features
    BalloonInfo for HList
    https://rt.cpan.org/Ticket/Display.html?id=55887
    Perl/Tk is now available at github.
    Improved "all widgets at a glance" demo.
* Tue Mar 15 2011 cfarrell@novell.com
- license update: (GPL+ or Artistic) and zlib
  More correct statement of the package license in Fedora
  compatible syntax as per http://is.gd/HtnxI9 and
  http://en.opensuse.org/openSUSE:Accepted_licences
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Mon Nov 29 2010 coolo@novell.com
- remove /var/adm/perl-modules
* Fri Nov 19 2010 coolo@novell.com
- newer Xorg define different include guards
* Tue Oct 19 2010 coolo@novell.com
- add perl as explicit buildrequire
* Mon Jul 19 2010 anicka@suse.cz
- update to 804.029
  * bugfixes, test fixes
- removed CVE-2006-4484 and per5.12 patches (fixed in upstream)
* Tue Apr 20 2010 anicka@suse.cz
- port utf fix for perl 5.12 from development version
* Thu Apr  8 2010 dmueller@suse.de
- require the right version of perl
* Sun Jan 10 2010 jengelh@medozas.de
- enable parallel build
* Mon Dec 14 2009 aj@suse.de
- Fix build to not run disabled tests.
* Tue Nov  3 2009 coolo@novell.com
- updated patches to apply with fuzz=0
* Mon Sep 29 2008 anicka@suse.cz
- call Xvfb with 24 bit color depth (bnc#430569)
* Mon Sep 29 2008 anicka@suse.cz
- fix event table in tkBind.c
* Tue Feb  5 2008 anicka@suse.cz
- fix CVE-2006-4484 [#357978]
* Thu Jan 17 2008 anicka@suse.cz
- update to 804.028 (this is not a stable version but works
  with perl 5.10 at least a little)
  * Tk::Animation now reads delay and disposal information from GIF
  file (experimental, may change, needs an installed Image::Info)
  * Implemented -overrelief,-repeatinterval,-repeatdelay for
  Tk::Button.
  * Additional item in the "widget" demonstration showing all Tk
  widgets.
  * Added BalloonInfo to NoteBook.
  * ptked: Encoding menu now with radiobuttons, also added some
  popular encodings to menu.
  * The undocumented method font('subfonts') returns now more
  diagnostics.
  * It's possible to use binary (and not anymore base64 encoded)
  - data for GIF files.
  * New -cancel_button option for Tk::DialogBox
  * Incompatible change:
  Return values of some Tk::Wm methods (e.g. aspect, wmGrid,
  iconposition, resizable ...) were changed from returning tclish
  lists (e.g. "1 2 3 4") to perlish lists (1,2,3,4). I believe the
  return values of these methods are rarely used.
  * Tk::Wm::wmTracing needs argument for setting on/off, without
  argument just return the current value.
  * The newest tkUnixWm.c from Tcl/Tk is now in the Perl/Tk code.
  This adds (experimental?) support for wm attributes -topmost,
  - zoomed, -fullscreen and other _NET_WM features (iconphoto)
  under Unix/X11.
  * Tk::Wm::stackorder was missing in Perl/Tk.
  * widget demonstration has a Ctrl-Q key binding.
  * ptksh: x is an alias for d (like in the perl debugger).
  * ptksh: use bold font for prompt.
  * Tk::Text: pasting selection with middle mouse sets cursor
  position now.
  This is consistent with behaviour in other toolkits.
  * Tk::Widget: translated UnderlineAmpersand etc. functions.
  * Tk::MsgBox: again in Tk, completely new translation from the
  Tcl/Tk original. Looks nicer and behaves better than
  messageBox through Tk::DialogBox.
  * bugfixes, test fixes, documentation fixes
- temporarily disable unicode.t test
* Fri Jun 22 2007 anicka@suse.cz
- split up the devel subpackage, move testing to %%check
* Tue Nov  7 2006 schwab@suse.de
- Fix reference counting.
* Sun Aug  6 2006 aj@suse.de
- Fix build with X11R7.
* Fri Jul  7 2006 anicka@suse.cz
- build with XFT=1 [#181927]
* Fri Feb 24 2006 anicka@suse.cz
- workaround segfault in tkEvent.c (#139552)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 16 2006 anicka@suse.cz
- compile with -fpic
* Mon Jan 16 2006 anicka@suse.cz
- update to 804.027
* Mon Apr 18 2005 mjancar@suse.de
- fix for gcc 4.0
* Sat Apr 24 2004 sndirsch@suse.de
- use xorg-x11 packages
* Sun Feb 22 2004 ro@suse.de
- added libusb and resmgr to neededforbuild
* Sat Jan 10 2004 adrian@suse.de
- add %%defattr
* Fri Jul 25 2003 choeger@suse.de
- use install_vendor and new %%perl_process_packlist macro
* Mon Jun  9 2003 mjancar@suse.cz
- use $RPM_OPT_FLAGS
* Mon May 19 2003 ro@suse.de
- remove unpackaged files
* Mon Feb  3 2003 ro@suse.de
- don't use Xnest
* Thu Dec  5 2002 prehak@suse.cz
- added freetype2 to neededforbuild
* Thu Nov 28 2002 prehak@suse.cz
- temporarily used Xnest server to work with Xvfb due to some changes
  in Xvfb that caused broken connection
* Mon Nov 11 2002 ro@suse.de
- updated neededforbuild after xf86-rename
* Tue Jul 30 2002 prehak@suse.cz
- update to new version 800.024
* Wed May 15 2002 ro@suse.de
- find correct x11-libs on lib64 platforms
* Mon Jan  7 2002 ro@suse.de
- added libusb to neededforbuild (for Xvfb)
* Mon Aug 20 2001 rvasice@suse.cz
- fixed perl path to /usr/bin/perl
* Fri Aug 17 2001 rvasice@suse.cz
- update to version 800.023
* Wed Apr 11 2001 schwab@suse.de
- Fix many warnings and type clashes.
- Make sure Xvfb is always killed.
* Sat Apr  7 2001 kukuk@suse.de
- Fix /bin/perl -> /usr/bin/perl
* Thu Apr  5 2001 ro@suse.de
- rename perl_tk -> perl-Tk
* Thu Apr  5 2001 ro@suse.de
- update to Tk800.022
* Thu Jan 18 2001 grimmer@suse.de
- Changed Group tag to Development/Libraries/Perl
* Fri Oct 27 2000 bk@suse.de
- fix permission of MANIFEST.SKIP(was 666)
* Mon Aug 21 2000 ro@suse.de
- adapted for perl-5.6
* Thu Jan 20 2000 ro@suse.de
- use macro for mandir
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Jul 12 1999 ro@suse.de
- update to 800.014
* Sun Jul 11 1999 ro@suse.de
- fixed perl-paths
* Wed Mar 17 1999 ro@suse.de
- diff cleanup
* Tue Feb  2 1999 ro@suse.de
- use wildcard in filelist for alpha (*-linux)
* Tue Nov 17 1998 ro@suse.de
- adjusted paths for perl5.005_02
* Thu Nov 12 1998 ro@suse.de
- respect different perl minor versions
* Thu Nov  5 1998 mb@suse.de
- initial version of perl_tk800.007
